package uraxis.programnodes.init;

import com.ur.urcap.api.contribution.ProgramNodeContribution;
import com.ur.urcap.api.contribution.program.ProgramAPIProvider;
import com.ur.urcap.api.domain.ProgramAPI;
import com.ur.urcap.api.domain.data.DataModel;
import com.ur.urcap.api.domain.script.ScriptWriter;
import com.ur.urcap.api.domain.undoredo.UndoRedoManager;
import com.ur.urcap.api.domain.userinteraction.keyboard.KeyboardInputCallback;
import com.ur.urcap.api.domain.userinteraction.keyboard.KeyboardInputFactory;
import com.ur.urcap.api.domain.userinteraction.keyboard.KeyboardNumberInput;
import uraxis.MyDaemonInstallationNodeContribution;

public class FestoInitNodeContribution implements ProgramNodeContribution {
    private final ProgramAPI programAPI;
    private final FestoInitNodeView view;
    private final DataModel model;

    public FestoInitNodeContribution(ProgramAPIProvider apiProvider, FestoInitNodeView view, DataModel model) {
        this.programAPI = apiProvider.getProgramAPI();
        this.view = view;
        this.model = model;
    }

    @Override
    public void openView() {

    }

    @Override
    public void closeView() {

    }

    @Override
    public String getTitle() {
        return "FestoInit";
    }

    @Override
    public void generateScript(ScriptWriter writer) {
        writer.appendLine(String.format("ret = %s.ready()", getInstallation().getXMLRPCVariable()));
        writer.appendLine("if (ret != \"OK\"):");
        writer.appendLine(String.format("popup(ret)"));
        writer.appendLine("end");
        writer.writeChildren();
    }

    private MyDaemonInstallationNodeContribution getInstallation() {
        return programAPI.getInstallationNode(MyDaemonInstallationNodeContribution.class);
    }

    @Override
    public boolean isDefined() {
        return true;
    }
}
