package uraxis.programnodes.init;

import com.ur.urcap.api.contribution.ViewAPIProvider;
import com.ur.urcap.api.contribution.program.ContributionConfiguration;
import com.ur.urcap.api.contribution.program.CreationContext;
import com.ur.urcap.api.contribution.program.ProgramAPIProvider;
import com.ur.urcap.api.contribution.program.swing.SwingProgramNodeService;
import com.ur.urcap.api.domain.SystemAPI;
import com.ur.urcap.api.domain.data.DataModel;
import uraxis.programnodes.Style;
import uraxis.programnodes.V5Style;

import java.util.Locale;

public class FestoInitNodeService implements SwingProgramNodeService<FestoInitNodeContribution, FestoInitNodeView> {


    @Override
    public String getId() {
        return "FestoInit";
    }

    @Override
    public void configureContribution(ContributionConfiguration configuration) {
        configuration.setChildrenAllowed(false);
    }

    @Override
    public String getTitle(Locale locale) {
        return "FestoInit";
    }

    @Override
    public FestoInitNodeView createView(ViewAPIProvider apiProvider) {
        SystemAPI systemAPI = apiProvider.getSystemAPI();
        Style style =  new V5Style();
        return new FestoInitNodeView(style);
    }

    @Override
    public FestoInitNodeContribution createNode(ProgramAPIProvider apiProvider, FestoInitNodeView view, DataModel model, CreationContext context) {
        return new FestoInitNodeContribution(apiProvider, view, model);
    }
}
