package uraxis.programnodes.init;

import com.ur.urcap.api.contribution.ContributionProvider;
import com.ur.urcap.api.contribution.program.swing.SwingProgramNodeView;
import uraxis.programnodes.Style;
import uraxis.programnodes.init.FestoInitNodeContribution;

import javax.swing.*;
import java.awt.*;

public class FestoInitNodeView implements SwingProgramNodeView<FestoInitNodeContribution>{

    private final Style style;

    public FestoInitNodeView(Style style) {
        this.style = style;
    }

    @Override
    public void buildUI(JPanel jPanel, final ContributionProvider<FestoInitNodeContribution> provider) {
        jPanel.setLayout(new BoxLayout(jPanel, BoxLayout.Y_AXIS));
        jPanel.add(createInfo());
        jPanel.add(createVerticalSpacing(style.getVerticalSpacing()));
        jPanel.add(createVerticalSpacing(style.getExtraLargeVerticalSpacing()));
    }

    private Component createVerticalSpacing(int height) {
        return Box.createRigidArea(new Dimension(0, height));
    }

    private Box createInfo () {
        Box infoBox = Box.createHorizontalBox () ;
        infoBox.setAlignmentX( Component.LEFT_ALIGNMENT );
        infoBox.add(new JLabel ("Set Festo Axis ready."));
        return infoBox ;
    }
}
